<template>
  <rui-loading v-if="!element" class="-mvd">{{ $t('generic.loading') }}</rui-loading>
  <div v-else>
    <div class="_container">
      <div class="-flex -gap -mtm">
        <rui-button v-show="$smallerThan('medium')" :to="backRoute" icon="caret-left" :title="$t('generic.back')" />
        <h2 class="-mv0 -flex--grow -text--ellipsis">{{ element.displayName }}</h2>
        <gpa-element-actions :element="element" context="inventory" breakpoint="medium" />
      </div>

      <div class="-flex--grow -align-self-end -pbt -inline-flex -gap">
        <em>{{ element.resource.latinName }}</em>
        <rui-button icon="info"
                    text
                    :title="$t('js.generic.show_details')"
                    variant="helping"
                    @click="$emitBus('show-resource-description', element.resource)" />
      </div>

      <div class="-grid-3 -gap">
        <section>
          <gpa-element-details :element="element" />
        </section>
      </div>
    </div>

    <rui-tabs class="-mtd">
      <rui-button :to="{name: `${baseRoutesName}-observations`}" icon="notebook" no-text-on-small>{{ $t('js.generic.observations') }}</rui-button>
      <rui-button :to="{name: `${baseRoutesName}-tasks`}" icon="checks" no-text-on-small>{{ $t('js.generic.tasks') }}</rui-button>
      <rui-button :to="{name: `${baseRoutesName}-harvests`}" icon="harvest" no-text-on-small>{{ $t('js.generic.harvests') }}</rui-button>
      <rui-toolbar-spring />
      <rui-button :to="{name: `${baseRoutesName}-activity`}" icon="activity" no-text-on-small>{{ $t('js.generic.activity') }}</rui-button>
    </rui-tabs>

    <router-view />
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiTabs from '@experiments-labs/rise_ui/src/components/Tabs/Tabs.vue'
import RuiToolbarSpring from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSpring.vue'

import GpaElementDetails from './Elements/_Details.vue'
import GpaElementActions from './Elements/_Actions.vue'

/**
 * @typedef {import('../../../classes/models/Element')} Element
 */

/**
 * Inventory page to display details on an Element
 */
export default {
  name: 'GpaInventoryElement',
  components: { RuiToolbarSpring, RuiTabs, RuiLoading, RuiButton, GpaElementDetails, GpaElementActions },
  data () {
    return {
      baseRoutesName: this.$route.name.includes('inventory-patch') ? 'inventory-patch-element' : 'inventory-element',
    }
  },
  computed: {
    /** @returns {Element} Element to display */
    element () { return this.$store.getters.element(parseInt(this.$route.params.elementId, 10)) },
    backRoute () { return this.$route.name.includes('inventory-element') ? { name: 'inventory' } : { name: 'inventory-patch-elements' } },
  },
}
</script>
